]> Pileus Git - ~andy/git/blob - git-am.sh
Merge branch 'ma/am-exclude'
[~andy/git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors      strip everything before a scissors line
21 whitespace=     pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory=      pass it through git-apply
25 exclude=        pass it through git-apply
26 C=              pass it through git-apply
27 p=              pass it through git-apply
28 patch-format=   format the patch(es) are in
29 reject          pass it through git-apply
30 resolvemsg=     override error message when patch failure occurs
31 continue        continue applying patches after resolving a conflict
32 r,resolved      synonyms for --continue
33 skip            skip the current patch
34 abort           restore the original branch and abort the patching operation.
35 committer-date-is-author-date    lie about committer date
36 ignore-date     use current timestamp for author date
37 rerere-autoupdate update the index with reused conflict resolution if possible
38 rebasing*       (internal use for git-rebase)"
39
40 . git-sh-setup
41 . git-sh-i18n
42 prefix=$(git rev-parse --show-prefix)
43 set_reflog_action am
44 require_work_tree
45 cd_to_toplevel
46
47 git var GIT_COMMITTER_IDENT >/dev/null ||
48         die "$(gettext "You need to set your committer info first")"
49
50 if git rev-parse --verify -q HEAD >/dev/null
51 then
52         HAS_HEAD=yes
53 else
54         HAS_HEAD=
55 fi
56
57 cmdline="git am"
58 if test '' != "$interactive"
59 then
60         cmdline="$cmdline -i"
61 fi
62 if test '' != "$threeway"
63 then
64         cmdline="$cmdline -3"
65 fi
66
67 sq () {
68         git rev-parse --sq-quote "$@"
69 }
70
71 stop_here () {
72     echo "$1" >"$dotest/next"
73     git rev-parse --verify -q HEAD >"$dotest/abort-safety"
74     exit 1
75 }
76
77 safe_to_abort () {
78         if test -f "$dotest/dirtyindex"
79         then
80                 return 1
81         fi
82
83         if ! test -s "$dotest/abort-safety"
84         then
85                 return 0
86         fi
87
88         abort_safety=$(cat "$dotest/abort-safety")
89         if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
90         then
91                 return 0
92         fi
93         (
94                 gettext "You seem to have moved HEAD since the last 'am' failure.
95 Not rewinding to ORIG_HEAD" &&
96                 echo
97         ) >&2
98         return 1
99 }
100
101 stop_here_user_resolve () {
102     if [ -n "$resolvemsg" ]; then
103             printf '%s\n' "$resolvemsg"
104             stop_here $1
105     fi
106     eval_gettext "When you have resolved this problem run \"\$cmdline --resolved\".
107 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
108 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
109
110     stop_here $1
111 }
112
113 go_next () {
114         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
115                 "$dotest/patch" "$dotest/info"
116         echo "$next" >"$dotest/next"
117         this=$next
118 }
119
120 cannot_fallback () {
121         echo "$1"
122         gettext "Cannot fall back to three-way merge."; echo
123         exit 1
124 }
125
126 fall_back_3way () {
127     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
128
129     rm -fr "$dotest"/patch-merge-*
130     mkdir "$dotest/patch-merge-tmp-dir"
131
132     # First see if the patch records the index info that we can use.
133     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
134         "$dotest/patch" &&
135     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136     git write-tree >"$dotest/patch-merge-base+" ||
137     cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
138
139     say Using index info to reconstruct a base tree...
140     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
141         git apply --cached <"$dotest/patch"
142     then
143         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
144         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
145     else
146         cannot_fallback "$(gettext "Did you hand edit your patch?
147 It does not apply to blobs recorded in its index.")"
148     fi
149
150     test -f "$dotest/patch-merge-index" &&
151     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
152     orig_tree=$(cat "$dotest/patch-merge-base") &&
153     rm -fr "$dotest"/patch-merge-* || exit 1
154
155     say "$(gettext "Falling back to patching base and 3-way merge...")"
156
157     # This is not so wrong.  Depending on which base we picked,
158     # orig_tree may be wildly different from ours, but his_tree
159     # has the same set of wildly different changes in parts the
160     # patch did not touch, so recursive ends up canceling them,
161     # saying that we reverted all those changes.
162
163     eval GITHEAD_$his_tree='"$FIRSTLINE"'
164     export GITHEAD_$his_tree
165     if test -n "$GIT_QUIET"
166     then
167             GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
168     fi
169     git-merge-recursive $orig_tree -- HEAD $his_tree || {
170             git rerere $allow_rerere_autoupdate
171             echo Failed to merge in the changes.
172             exit 1
173     }
174     unset GITHEAD_$his_tree
175 }
176
177 clean_abort () {
178         test $# = 0 || echo >&2 "$@"
179         rm -fr "$dotest"
180         exit 1
181 }
182
183 patch_format=
184
185 check_patch_format () {
186         # early return if patch_format was set from the command line
187         if test -n "$patch_format"
188         then
189                 return 0
190         fi
191
192         # we default to mbox format if input is from stdin and for
193         # directories
194         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
195         then
196                 patch_format=mbox
197                 return 0
198         fi
199
200         # otherwise, check the first few lines of the first patch to try
201         # to detect its format
202         {
203                 read l1
204                 read l2
205                 read l3
206                 case "$l1" in
207                 "From "* | "From: "*)
208                         patch_format=mbox
209                         ;;
210                 '# This series applies on GIT commit'*)
211                         patch_format=stgit-series
212                         ;;
213                 "# HG changeset patch")
214                         patch_format=hg
215                         ;;
216                 *)
217                         # if the second line is empty and the third is
218                         # a From, Author or Date entry, this is very
219                         # likely an StGIT patch
220                         case "$l2,$l3" in
221                         ,"From: "* | ,"Author: "* | ,"Date: "*)
222                                 patch_format=stgit
223                                 ;;
224                         *)
225                                 ;;
226                         esac
227                         ;;
228                 esac
229                 if test -z "$patch_format" &&
230                         test -n "$l1" &&
231                         test -n "$l2" &&
232                         test -n "$l3"
233                 then
234                         # This begins with three non-empty lines.  Is this a
235                         # piece of e-mail a-la RFC2822?  Grab all the headers,
236                         # discarding the indented remainder of folded lines,
237                         # and see if it looks like that they all begin with the
238                         # header field names...
239                         tr -d '\015' <"$1" |
240                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
241                         sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
242                         patch_format=mbox
243                 fi
244         } < "$1" || clean_abort
245 }
246
247 split_patches () {
248         case "$patch_format" in
249         mbox)
250                 if test -n "$rebasing" || test t = "$keepcr"
251                 then
252                     keep_cr=--keep-cr
253                 else
254                     keep_cr=
255                 fi
256                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
257                 clean_abort
258                 ;;
259         stgit-series)
260                 if test $# -ne 1
261                 then
262                         clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
263                 fi
264                 series_dir=`dirname "$1"`
265                 series_file="$1"
266                 shift
267                 {
268                         set x
269                         while read filename
270                         do
271                                 set "$@" "$series_dir/$filename"
272                         done
273                         # remove the safety x
274                         shift
275                         # remove the arg coming from the first-line comment
276                         shift
277                 } < "$series_file" || clean_abort
278                 # set the patch format appropriately
279                 patch_format=stgit
280                 # now handle the actual StGIT patches
281                 split_patches "$@"
282                 ;;
283         stgit)
284                 this=0
285                 for stgit in "$@"
286                 do
287                         this=`expr "$this" + 1`
288                         msgnum=`printf "%0${prec}d" $this`
289                         # Perl version of StGIT parse_patch. The first nonemptyline
290                         # not starting with Author, From or Date is the
291                         # subject, and the body starts with the next nonempty
292                         # line not starting with Author, From or Date
293                         perl -ne 'BEGIN { $subject = 0 }
294                                 if ($subject > 1) { print ; }
295                                 elsif (/^\s+$/) { next ; }
296                                 elsif (/^Author:/) { print s/Author/From/ ; }
297                                 elsif (/^(From|Date)/) { print ; }
298                                 elsif ($subject) {
299                                         $subject = 2 ;
300                                         print "\n" ;
301                                         print ;
302                                 } else {
303                                         print "Subject: ", $_ ;
304                                         $subject = 1;
305                                 }
306                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
307                 done
308                 echo "$this" > "$dotest/last"
309                 this=
310                 msgnum=
311                 ;;
312         *)
313                 if test -n "$parse_patch" ; then
314                         clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
315                 else
316                         clean_abort "$(gettext "Patch format detection failed.")"
317                 fi
318                 ;;
319         esac
320 }
321
322 prec=4
323 dotest="$GIT_DIR/rebase-apply"
324 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
325 resolvemsg= resume= scissors= no_inbody_headers=
326 git_apply_opt=
327 committer_date_is_author_date=
328 ignore_date=
329 allow_rerere_autoupdate=
330
331 if test "$(git config --bool --get am.keepcr)" = true
332 then
333     keepcr=t
334 fi
335
336 while test $# != 0
337 do
338         case "$1" in
339         -i|--interactive)
340                 interactive=t ;;
341         -b|--binary)
342                 : ;;
343         -3|--3way)
344                 threeway=t ;;
345         -s|--signoff)
346                 sign=t ;;
347         -u|--utf8)
348                 utf8=t ;; # this is now default
349         --no-utf8)
350                 utf8= ;;
351         -k|--keep)
352                 keep=t ;;
353         -c|--scissors)
354                 scissors=t ;;
355         --no-scissors)
356                 scissors=f ;;
357         -r|--resolved|--continue)
358                 resolved=t ;;
359         --skip)
360                 skip=t ;;
361         --abort)
362                 abort=t ;;
363         --rebasing)
364                 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
365         -d|--dotest)
366                 die "$(gettext "-d option is no longer supported.  Do not use.")"
367                 ;;
368         --resolvemsg)
369                 shift; resolvemsg=$1 ;;
370         --whitespace|--directory|--exclude)
371                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
372         -C|-p)
373                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
374         --patch-format)
375                 shift ; patch_format="$1" ;;
376         --reject|--ignore-whitespace|--ignore-space-change)
377                 git_apply_opt="$git_apply_opt $1" ;;
378         --committer-date-is-author-date)
379                 committer_date_is_author_date=t ;;
380         --ignore-date)
381                 ignore_date=t ;;
382         --rerere-autoupdate|--no-rerere-autoupdate)
383                 allow_rerere_autoupdate="$1" ;;
384         -q|--quiet)
385                 GIT_QUIET=t ;;
386         --keep-cr)
387                 keepcr=t ;;
388         --no-keep-cr)
389                 keepcr=f ;;
390         --)
391                 shift; break ;;
392         *)
393                 usage ;;
394         esac
395         shift
396 done
397
398 # If the dotest directory exists, but we have finished applying all the
399 # patches in them, clear it out.
400 if test -d "$dotest" &&
401    last=$(cat "$dotest/last") &&
402    next=$(cat "$dotest/next") &&
403    test $# != 0 &&
404    test "$next" -gt "$last"
405 then
406    rm -fr "$dotest"
407 fi
408
409 if test -d "$dotest"
410 then
411         case "$#,$skip$resolved$abort" in
412         0,*t*)
413                 # Explicit resume command and we do not have file, so
414                 # we are happy.
415                 : ;;
416         0,)
417                 # No file input but without resume parameters; catch
418                 # user error to feed us a patch from standard input
419                 # when there is already $dotest.  This is somewhat
420                 # unreliable -- stdin could be /dev/null for example
421                 # and the caller did not intend to feed us a patch but
422                 # wanted to continue unattended.
423                 test -t 0
424                 ;;
425         *)
426                 false
427                 ;;
428         esac ||
429         die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
430         resume=yes
431
432         case "$skip,$abort" in
433         t,t)
434                 die "$(gettext "Please make up your mind. --skip or --abort?")"
435                 ;;
436         t,)
437                 git rerere clear
438                 git read-tree --reset -u HEAD HEAD
439                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
440                 git reset HEAD
441                 git update-ref ORIG_HEAD $orig_head
442                 ;;
443         ,t)
444                 if test -f "$dotest/rebasing"
445                 then
446                         exec git rebase --abort
447                 fi
448                 git rerere clear
449                 if safe_to_abort
450                 then
451                         git read-tree --reset -u HEAD ORIG_HEAD
452                         git reset ORIG_HEAD
453                 fi
454                 rm -fr "$dotest"
455                 exit ;;
456         esac
457         rm -f "$dotest/dirtyindex"
458 else
459         # Make sure we are not given --skip, --resolved, nor --abort
460         test "$skip$resolved$abort" = "" ||
461                 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
462
463         # Start afresh.
464         mkdir -p "$dotest" || exit
465
466         if test -n "$prefix" && test $# != 0
467         then
468                 first=t
469                 for arg
470                 do
471                         test -n "$first" && {
472                                 set x
473                                 first=
474                         }
475                         if is_absolute_path "$arg"
476                         then
477                                 set "$@" "$arg"
478                         else
479                                 set "$@" "$prefix$arg"
480                         fi
481                 done
482                 shift
483         fi
484
485         check_patch_format "$@"
486
487         split_patches "$@"
488
489         # -i can and must be given when resuming; everything
490         # else is kept
491         echo " $git_apply_opt" >"$dotest/apply-opt"
492         echo "$threeway" >"$dotest/threeway"
493         echo "$sign" >"$dotest/sign"
494         echo "$utf8" >"$dotest/utf8"
495         echo "$keep" >"$dotest/keep"
496         echo "$keepcr" >"$dotest/keepcr"
497         echo "$scissors" >"$dotest/scissors"
498         echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
499         echo "$GIT_QUIET" >"$dotest/quiet"
500         echo 1 >"$dotest/next"
501         if test -n "$rebasing"
502         then
503                 : >"$dotest/rebasing"
504         else
505                 : >"$dotest/applying"
506                 if test -n "$HAS_HEAD"
507                 then
508                         git update-ref ORIG_HEAD HEAD
509                 else
510                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
511                 fi
512         fi
513 fi
514
515 git update-index -q --refresh
516
517 case "$resolved" in
518 '')
519         case "$HAS_HEAD" in
520         '')
521                 files=$(git ls-files) ;;
522         ?*)
523                 files=$(git diff-index --cached --name-only HEAD --) ;;
524         esac || exit
525         if test "$files"
526         then
527                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
528                 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
529         fi
530 esac
531
532 if test "$(cat "$dotest/utf8")" = t
533 then
534         utf8=-u
535 else
536         utf8=-n
537 fi
538 if test "$(cat "$dotest/keep")" = t
539 then
540         keep=-k
541 fi
542 case "$(cat "$dotest/keepcr")" in
543 t)
544         keepcr=--keep-cr ;;
545 f)
546         keepcr=--no-keep-cr ;;
547 esac
548 case "$(cat "$dotest/scissors")" in
549 t)
550         scissors=--scissors ;;
551 f)
552         scissors=--no-scissors ;;
553 esac
554 if test "$(cat "$dotest/no_inbody_headers")" = t
555 then
556         no_inbody_headers=--no-inbody-headers
557 else
558         no_inbody_headers=
559 fi
560 if test "$(cat "$dotest/quiet")" = t
561 then
562         GIT_QUIET=t
563 fi
564 if test "$(cat "$dotest/threeway")" = t
565 then
566         threeway=t
567 fi
568 git_apply_opt=$(cat "$dotest/apply-opt")
569 if test "$(cat "$dotest/sign")" = t
570 then
571         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
572                         s/>.*/>/
573                         s/^/Signed-off-by: /'
574                 `
575 else
576         SIGNOFF=
577 fi
578
579 last=`cat "$dotest/last"`
580 this=`cat "$dotest/next"`
581 if test "$skip" = t
582 then
583         this=`expr "$this" + 1`
584         resume=
585 fi
586
587 while test "$this" -le "$last"
588 do
589         msgnum=`printf "%0${prec}d" $this`
590         next=`expr "$this" + 1`
591         test -f "$dotest/$msgnum" || {
592                 resume=
593                 go_next
594                 continue
595         }
596
597         # If we are not resuming, parse and extract the patch information
598         # into separate files:
599         #  - info records the authorship and title
600         #  - msg is the rest of commit log message
601         #  - patch is the patch body.
602         #
603         # When we are resuming, these files are either already prepared
604         # by the user, or the user can tell us to do so by --resolved flag.
605         case "$resume" in
606         '')
607                 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
608                         <"$dotest/$msgnum" >"$dotest/info" ||
609                         stop_here $this
610
611                 # skip pine's internal folder data
612                 sane_grep '^Author: Mail System Internal Data$' \
613                         <"$dotest"/info >/dev/null &&
614                         go_next && continue
615
616                 test -s "$dotest/patch" || {
617                         eval_gettext "Patch is empty.  Was it split wrong?
618 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
619 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
620                         stop_here $this
621                 }
622                 rm -f "$dotest/original-commit" "$dotest/author-script"
623                 if test -f "$dotest/rebasing" &&
624                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
625                                 -e q "$dotest/$msgnum") &&
626                         test "$(git cat-file -t "$commit")" = commit
627                 then
628                         git cat-file commit "$commit" |
629                         sed -e '1,/^$/d' >"$dotest/msg-clean"
630                         echo "$commit" > "$dotest/original-commit"
631                         get_author_ident_from_commit "$commit" > "$dotest/author-script"
632                 else
633                         {
634                                 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
635                                 echo
636                                 cat "$dotest/msg"
637                         } |
638                         git stripspace > "$dotest/msg-clean"
639                 fi
640                 ;;
641         esac
642
643         if test -f "$dotest/author-script"
644         then
645                 eval $(cat "$dotest/author-script")
646         else
647                 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
648                 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
649                 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
650         fi
651
652         if test -z "$GIT_AUTHOR_EMAIL"
653         then
654                 gettext "Patch does not have a valid e-mail address."; echo
655                 stop_here $this
656         fi
657
658         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
659
660         case "$resume" in
661         '')
662             if test '' != "$SIGNOFF"
663             then
664                 LAST_SIGNED_OFF_BY=`
665                     sed -ne '/^Signed-off-by: /p' \
666                     "$dotest/msg-clean" |
667                     sed -ne '$p'
668                 `
669                 ADD_SIGNOFF=`
670                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
671                     test '' = "$LAST_SIGNED_OFF_BY" && echo
672                     echo "$SIGNOFF"
673                 }`
674             else
675                 ADD_SIGNOFF=
676             fi
677             {
678                 if test -s "$dotest/msg-clean"
679                 then
680                         cat "$dotest/msg-clean"
681                 fi
682                 if test '' != "$ADD_SIGNOFF"
683                 then
684                         echo "$ADD_SIGNOFF"
685                 fi
686             } >"$dotest/final-commit"
687             ;;
688         *)
689                 case "$resolved$interactive" in
690                 tt)
691                         # This is used only for interactive view option.
692                         git diff-index -p --cached HEAD -- >"$dotest/patch"
693                         ;;
694                 esac
695         esac
696
697         resume=
698         if test "$interactive" = t
699         then
700             test -t 0 ||
701             die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
702             action=again
703             while test "$action" = again
704             do
705                 gettext "Commit Body is:"; echo
706                 echo "--------------------------"
707                 cat "$dotest/final-commit"
708                 echo "--------------------------"
709                 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
710                 # in your translation. The program will only accept English
711                 # input at this point.
712                 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
713                 read reply
714                 case "$reply" in
715                 [yY]*) action=yes ;;
716                 [aA]*) action=yes interactive= ;;
717                 [nN]*) action=skip ;;
718                 [eE]*) git_editor "$dotest/final-commit"
719                        action=again ;;
720                 [vV]*) action=again
721                        git_pager "$dotest/patch" ;;
722                 *)     action=again ;;
723                 esac
724             done
725         else
726             action=yes
727         fi
728
729         if test -f "$dotest/final-commit"
730         then
731                 FIRSTLINE=$(sed 1q "$dotest/final-commit")
732         else
733                 FIRSTLINE=""
734         fi
735
736         if test $action = skip
737         then
738                 go_next
739                 continue
740         fi
741
742         if test -x "$GIT_DIR"/hooks/applypatch-msg
743         then
744                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
745                 stop_here $this
746         fi
747
748         say "$(eval_gettext "Applying: \$FIRSTLINE")"
749
750         case "$resolved" in
751         '')
752                 # When we are allowed to fall back to 3-way later, don't give
753                 # false errors during the initial attempt.
754                 squelch=
755                 if test "$threeway" = t
756                 then
757                         squelch='>/dev/null 2>&1 '
758                 fi
759                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
760                 apply_status=$?
761                 ;;
762         t)
763                 # Resolved means the user did all the hard work, and
764                 # we do not have to do any patch application.  Just
765                 # trust what the user has in the index file and the
766                 # working tree.
767                 resolved=
768                 git diff-index --quiet --cached HEAD -- && {
769                         gettext "No changes - did you forget to use 'git add'?
770 If there is nothing left to stage, chances are that something else
771 already introduced the same changes; you might want to skip this patch."; echo
772                         stop_here_user_resolve $this
773                 }
774                 unmerged=$(git ls-files -u)
775                 if test -n "$unmerged"
776                 then
777                         gettext "You still have unmerged paths in your index
778 did you forget to use 'git add'?"; echo
779                         stop_here_user_resolve $this
780                 fi
781                 apply_status=0
782                 git rerere
783                 ;;
784         esac
785
786         if test $apply_status != 0 && test "$threeway" = t
787         then
788                 if (fall_back_3way)
789                 then
790                     # Applying the patch to an earlier tree and merging the
791                     # result may have produced the same tree as ours.
792                     git diff-index --quiet --cached HEAD -- && {
793                         say "$(gettext "No changes -- Patch already applied.")"
794                         go_next
795                         continue
796                     }
797                     # clear apply_status -- we have successfully merged.
798                     apply_status=0
799                 fi
800         fi
801         if test $apply_status != 0
802         then
803                 eval_gettext 'Patch failed at $msgnum $FIRSTLINE'; echo
804                 stop_here_user_resolve $this
805         fi
806
807         if test -x "$GIT_DIR"/hooks/pre-applypatch
808         then
809                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
810         fi
811
812         tree=$(git write-tree) &&
813         commit=$(
814                 if test -n "$ignore_date"
815                 then
816                         GIT_AUTHOR_DATE=
817                 fi
818                 parent=$(git rev-parse --verify -q HEAD) ||
819                 say >&2 "$(gettext "applying to an empty history")"
820
821                 if test -n "$committer_date_is_author_date"
822                 then
823                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
824                         export GIT_COMMITTER_DATE
825                 fi &&
826                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
827         ) &&
828         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
829         stop_here $this
830
831         if test -f "$dotest/original-commit"; then
832                 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
833         fi
834
835         if test -x "$GIT_DIR"/hooks/post-applypatch
836         then
837                 "$GIT_DIR"/hooks/post-applypatch
838         fi
839
840         go_next
841 done
842
843 if test -s "$dotest"/rewritten; then
844     git notes copy --for-rewrite=rebase < "$dotest"/rewritten
845     if test -x "$GIT_DIR"/hooks/post-rewrite; then
846         "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
847     fi
848 fi
849
850 rm -fr "$dotest"
851 git gc --auto